"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ClientConfigSchema = void 0;
const zod_1 = require("zod");
const ClientTLSConfigSchema = zod_1.z.object({
    tls_strategy: zod_1.z.enum(['tls', 'mtls']).optional(),
    cert_file: zod_1.z.string().optional(),
    ca_file: zod_1.z.string().optional(),
    key_file: zod_1.z.string().optional(),
    server_name: zod_1.z.string().optional(),
});
exports.ClientConfigSchema = zod_1.z.object({
    token: zod_1.z.string(),
    tls_config: ClientTLSConfigSchema,
    host_port: zod_1.z.string(),
    api_url: zod_1.z.string(),
    log_level: zod_1.z.enum(['OFF', 'DEBUG', 'INFO', 'WARN', 'ERROR']).optional(),
    tenant_id: zod_1.z.string(),
});
