import { Channel, ClientFactory } from 'nice-grpc';
import { DispatcherClient as PbDispatcherClient } from '../../protoc/dispatcher';
import { ClientConfig } from '../hatchet-client/client-config';
import { Logger } from '../../util/logger';
export declare enum StepRunEventType {
    STEP_RUN_EVENT_TYPE_STARTED = "STEP_RUN_EVENT_TYPE_STARTED",
    STEP_RUN_EVENT_TYPE_COMPLETED = "STEP_RUN_EVENT_TYPE_COMPLETED",
    STEP_RUN_EVENT_TYPE_FAILED = "STEP_RUN_EVENT_TYPE_FAILED",
    STEP_RUN_EVENT_TYPE_CANCELLED = "STEP_RUN_EVENT_TYPE_CANCELLED",
    STEP_RUN_EVENT_TYPE_TIMED_OUT = "STEP_RUN_EVENT_TYPE_TIMED_OUT"
}
export interface StepRunEvent {
    type: StepRunEventType;
    payload: string;
}
export declare class ListenerClient {
    config: ClientConfig;
    client: PbDispatcherClient;
    logger: Logger;
    constructor(config: ClientConfig, channel: Channel, factory: ClientFactory);
    on(workflowRunId: string, handler: (event: StepRunEvent) => Promise<void>): Promise<void>;
    retrySubscribe(workflowRunId: string): Promise<AsyncIterable<import("../../protoc/dispatcher").WorkflowEvent>>;
}
