"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAddressesFromJWT = exports.getTenantIdFromJWT = void 0;
function getTenantIdFromJWT(token) {
    const claims = extractClaimsFromJWT(token);
    return claims.sub;
}
exports.getTenantIdFromJWT = getTenantIdFromJWT;
function getAddressesFromJWT(token) {
    const claims = extractClaimsFromJWT(token);
    return {
        serverUrl: claims.server_url,
        grpcBroadcastAddress: claims.grpc_broadcast_address,
    };
}
exports.getAddressesFromJWT = getAddressesFromJWT;
function extractClaimsFromJWT(token) {
    const parts = token.split('.');
    if (parts.length !== 3) {
        throw new Error('Invalid token format');
    }
    const claimsPart = parts[1];
    const claimsData = atob(claimsPart.replace(/-/g, '+').replace(/_/g, '/'));
    const claims = JSON.parse(claimsData);
    return claims;
}
